#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
//#include <sys/types.h>
#include <pthread.h>
#include <glib/gi18n.h>
#include <gtk/gtk.h>
#include "gwifimeter.h"
#include "scan.h"
#include "callback.h"
#include "interface.h"

pthread_mutex_t muteks = PTHREAD_MUTEX_INITIALIZER; 
#define ICONS_DIR PACKAGE_DATA_DIR G_DIR_SEPARATOR_S "themes/icons/"

GtkWidget * scan (GtkWidget * viewport1 )
{

    char *tab3;

        GtkTextIter iter ,start;
        gtk_text_buffer_get_iter_at_offset(gtk_text_view_get_buffer(GTK_TEXT_VIEW(pdata->textview2)),&iter, -1);
        gtk_text_buffer_get_start_iter (gtk_text_view_get_buffer (GTK_TEXT_VIEW (pdata->textview2)), &start);
        gtk_text_buffer_delete(gtk_text_view_get_buffer (GTK_TEXT_VIEW (pdata->textview2)),&start,&iter);

        tab3 = readfunc(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwlist)),pdata->interface,"scan",2);
        compresspaces(tab3);
        gtk_text_buffer_get_iter_at_offset (gtk_text_view_get_buffer (GTK_TEXT_VIEW (pdata->textview2)), &iter, -1);
        gtk_text_buffer_insert(gtk_text_view_get_buffer (GTK_TEXT_VIEW (pdata->textview2)),&iter,tab3,-1);
        gdk_flush ();
                GtkWidget * winnnet = scan_con(tab3,viewport1);
                g_free(tab3);
    return winnnet;
}
void setnet(gpointer user_data)
{
    pthread_mutex_lock(&muteks);
    struct structure *tab_struct = user_data ;
    char *tab3,*tab2,*tab1;
    tab2 = tab_struct->cell;
    gtk_entry_set_text (GTK_ENTRY (pdata->entry_nazwa),tab_struct->essid);
	gtk_entry_set_text (GTK_ENTRY (GTK_BIN ((pdata->comboboxentry1))->child), (tab_struct->essid));
    tab1=(char *) g_malloc(strlen(tab_struct->essid)+4);
    strcpy(tab1,"\"");
    strcat(tab1,tab_struct->essid);
    strcat(tab1,"\"");

    if ((tab3=strstr(tab2,tab1))!=NULL)
    {
        while (1)
        {
            --tab3 ;
            if (strstr(tab3,"Cell")!=NULL)
            {
                tab3 = tab3 + 4;
                break;
            }
        }
        if (strstr(tab3,"Mode:Ad-Hoc")!=NULL)
        {
            gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_mode),1);
        }
        else if (strstr(tab3,"Mode:Ad-Hoc")==NULL)
        {
            gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_mode),0);
        }
//Encryption key:off
        gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_keymode),0);
		gtk_entry_set_text (GTK_ENTRY (pdata->entry_key),"");
        if (strstr(tab3,"key:off")==NULL)
        {
            if (strstr(tab3,"WPA")!=NULL)
                {
                gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_keymode),3);
                if (strstr(tab3,"CCMP")!=NULL)gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_keymode),4);
                }
            else gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_keymode),1);
        }

        if (strstr(tab3,"Channel")!=NULL)
        {
            gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_channel),atoi(strstr(tab3,"Channel")+8));
        }
        else if (strstr(tab3,"Channel")==NULL)
        {
            gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_channel),0);
        }
    }
    g_free(tab1);
    pthread_mutex_unlock(&muteks);
    gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_ip),1);
    gtk_entry_set_text (GTK_ENTRY (pdata->entry_ip),"");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(pdata->checkbutton7),TRUE);
	
    if (strstr(tab3,"key:off")==NULL)pdata->netkey = netkey();
	else 
	{
		gtk_button_clicked (GTK_BUTTON(pdata->save_profil));
		gtk_button_clicked (GTK_BUTTON(pdata->button_connect));
	}
	scannend(pdata->scann);
}
void getnet(gpointer user_data)
{
    pthread_mutex_lock(&muteks);
    struct structure *tab_struct = user_data ;
//printf("test2 essid - %s\n",tab_struct->essid);

    char *tab3,*tab2,*tab1;
    tab2 = tab_struct->cell;
//GtkTextIter end ,start;
    gtk_entry_set_text (GTK_ENTRY (pdata->entry_nazwa),tab_struct->essid);
    tab1=(char *) g_malloc(strlen(tab_struct->essid)+4);
    strcpy(tab1,"\"");
    strcat(tab1,tab_struct->essid);
    strcat(tab1,"\"");

    if ((tab3=strstr(tab2,tab1))!=NULL)
    {
        while (1)
        {
            --tab3 ;
            if (strstr(tab3,"Cell")!=NULL)
            {
                tab3 = tab3 + 4;
                break;
            }
        }
        if (strstr(tab3,"Mode:Ad-Hoc")!=NULL)
        {
            gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_mode),1);
        }
        else if (strstr(tab3,"Mode:Ad-Hoc")==NULL)
        {
            gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_mode),0);
        }
//Encryption key:off
        gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_keymode),0);
		gtk_entry_set_text (GTK_ENTRY (pdata->entry_key),"");
        if (strstr(tab3,"key:off")==NULL)
        {
            if (strstr(tab3,"WPA")!=NULL)
                {
                gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_keymode),3);
                if (strstr(tab3,"CCMP")!=NULL)gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_keymode),4);
                }
            else gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_keymode),1);
        }

        if (strstr(tab3,"Channel")!=NULL)
        {
            gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_channel),atoi(strstr(tab3,"Channel")+8));
        }
        else if (strstr(tab3,"Channel")==NULL)
        {
            gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_channel),0);
        }
    }
    g_free(tab1);
    //gtk_widget_destroy (pdata->scann);
    scannend(pdata->scann);
    pthread_mutex_unlock(&muteks);
}

GtkWidget * scan_con(char * dane,GtkWidget * viewport1)
{
    GtkWidget *vbox_con = gtk_vbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (viewport1), vbox_con);
    gtk_widget_show (vbox_con);
    gtk_container_set_border_width (GTK_CONTAINER (vbox_con), 10);

    pdata->tab_struct = (struct structure **)g_malloc(sizeof(struct structure *));
    gchar * buf ;
    char * mode,*essid = dane,*signal,*cell1,*cell2;
    gint len=0;
    gdouble stan =0;
    cell1 = strstr(essid,"Cell");
    while (1)
    {
        essid = strstr(essid,"ESSID");
        if (essid != NULL)
        {
            essid=essid+7;
            mode = strstr(essid,"\"");
            if (mode!=NULL)
            {
                pdata->tab_struct = (struct structure **)g_realloc(pdata->tab_struct,(len+1) * sizeof(struct structure *));
                pdata->tab_struct[len] = (struct structure *)malloc(sizeof(struct structure));

                if (cell1!=NULL)
                {
                    cell2 = strstr(cell1+1,"Cell");
                    if (cell2!=NULL){*cell2 ='\0'; strcpy(pdata->tab_struct[len]->cell = (gchar *)g_malloc(strlen(cell1)+1),cell1); *cell2 ='C'; cell1 = cell2;}
                    else {strcpy(pdata->tab_struct[len]->cell = (gchar *)g_malloc(strlen(cell1)+1),cell1); cell1 = NULL;}
                }

                pdata->tab_struct[len]->hbox = gtk_hbox_new (FALSE, 0);
                gtk_widget_show (pdata->tab_struct[len]->hbox);
                gtk_box_pack_start (GTK_BOX (vbox_con), pdata->tab_struct[len]->hbox, FALSE, FALSE, 0);

                pdata->tab_struct[len]->button = gtk_button_new_with_mnemonic (_("Set"));
                gtk_widget_show (pdata->tab_struct[len]->button);
                gtk_box_pack_start (GTK_BOX (pdata->tab_struct[len]->hbox), pdata->tab_struct[len]->button, FALSE, FALSE, 0);

                pdata->tab_struct[len]->button1 = gtk_button_new_with_mnemonic (_("Connect"));
                gtk_widget_show (pdata->tab_struct[len]->button1);
                gtk_box_pack_start (GTK_BOX (pdata->tab_struct[len]->hbox), pdata->tab_struct[len]->button1, FALSE, FALSE, 0);

                pdata->tab_struct[len]->progress = gtk_progress_bar_new();
                gtk_progress_bar_set_text(GTK_PROGRESS_BAR(pdata->tab_struct[len]->progress)," ");
                gtk_progress_bar_set_bar_style (GTK_PROGRESS_BAR(pdata->tab_struct[len]->progress), GTK_PROGRESS_CONTINUOUS);
                gtk_widget_set_size_request (pdata->tab_struct[len]->progress, 220, -1);
                gtk_box_pack_start (GTK_BOX (pdata->tab_struct[len]->hbox), pdata->tab_struct[len]->progress, FALSE, FALSE, 0);
                gtk_widget_show (pdata->tab_struct[len]->progress);


                *mode = '\0';

                strcpy(pdata->tab_struct[len]->essid = (gchar *)g_malloc(strlen(essid)+1),essid);
                g_signal_connect_swapped ((gpointer) pdata->tab_struct[len]->button, "clicked",G_CALLBACK (getnet),pdata->tab_struct[len]);
                g_signal_connect_swapped ((gpointer) pdata->tab_struct[len]->button1, "clicked",G_CALLBACK (setnet),pdata->tab_struct[len]);

                strcpy(buf = (gchar *)g_malloc(sizeof(essid)+100),essid);
                *mode = '"';//          Signal level:-
                signal = strstr(essid,"key:off");
                if (signal == NULL)
                {

                    gchar *buf = (char*)g_malloc(100);
                    strcpy(buf,ICONS_DIR);
					strcat(buf,pdata->diricon);
                    if (find(buf,"keyon.png")>0)
                    {
                        strcat(buf,"/keyon.png");
                        pdata->tab_struct[len]->image = gtk_image_new_from_file ( buf);
                        gtk_box_pack_start (GTK_BOX (pdata->tab_struct[len]->hbox), pdata->tab_struct[len]->image, FALSE, FALSE, 0);
                        gtk_widget_show (pdata->tab_struct[len]->image);
                    }
                    else
                    {
                        pdata->tab_struct[len]->label = gtk_label_new ("  key:on");
                        gtk_box_pack_start (GTK_BOX (pdata->tab_struct[len]->hbox), pdata->tab_struct[len]->label, FALSE, FALSE, 0);
                        gtk_widget_show (pdata->tab_struct[len]->label);
                    }
                    g_free(buf);
                }

                signal = strstr(essid,"Signal level");
                if (signal != NULL){
                    if (*(signal+15)==' ')
                    {*(signal+15) = '\0';
                        strcat(buf ," ");
                        strcat(buf ,signal+14);
                        *(signal+15)=' ';
                        strcat(buf ," dbm");
                    }
                    if (*(signal+16)==' '){
                        *(signal+16) = '\0';
                        strcat(buf ," ");
                        strcat(buf ,signal+14);
                        *(signal+16)=' ';
                        strcat(buf ," dbm");
                    }
                    if (*(signal+17)==' '){
                        *(signal+17) = '\0';
                        strcat(buf ," ");
                        strcat(buf ,signal+14);
                        *(signal+17)=' ';
                        strcat(buf ," dbm");
                    }
                    stan = atoi(signal+14);
                    if (stan >= 100 )stan =100;
                    stan = (100 - stan)/100;
                }
                gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(pdata->tab_struct[len]->progress),stan);
                gtk_progress_bar_set_text(GTK_PROGRESS_BAR(pdata->tab_struct[len]->progress),buf);
                g_free(buf);
                ++len;
            }

        }
        else  break ;
    }
    pdata->lenscan=len;
    if (len==0)
    {
        GtkWidget *lab_pas = gtk_label_new (_("No network found"));
        gtk_box_pack_start (GTK_BOX (vbox_con), lab_pas, TRUE, TRUE, 0);
        gtk_widget_show (lab_pas);
    }
        return vbox_con;
}
void freescan(void)
{
int len=pdata->lenscan;
//printf("len - %d\n",len);
while(len)
        {
        --len;
        printf("freescan - %d\n",len);
        free(pdata->tab_struct[len]->essid);
        free(pdata->tab_struct[len]->cell);
        free(pdata->tab_struct[len]);
        
        }
        
}
void scannend(GtkWidget * widget)
{
gtk_widget_destroy (widget);
pdata->scann=NULL;	
pdata->scantest = 0;
}
void scancon (void *args  )//thread autoscan
{
        while(1)
        {
        sleep(3);
        pthread_mutex_lock(&muteks);
        if(pdata->scantest==0){
                                pthread_mutex_unlock(&muteks);
                                break;
                                }
        gdk_threads_enter();
        gtk_button_clicked (GTK_BUTTON(pdata->button_rescann));
        gdk_threads_leave();
        pthread_mutex_unlock(&muteks);
        }
}
void scannstart (void )  //scann clicked
{
    pdata->scann = okno_scan();
}
void rescann(GtkWidget * widget)
{
gtk_widget_destroy (pdata->scann1);
usleep(100000);
pdata->scann1 = scan (widget );
}
void toggled2 ( void )
{
    if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton2)))//active
    {
     pdata->scantest=1;
     GError    *err1 = NULL ;
     g_thread_pool_push(scanning,GUINT_TO_POINTER (1),&err1);
    } 
    else //unactive
    {
     pdata->scantest=0;
    }
}
void netkeyset (GtkWidget *entry)
{
    gtk_entry_set_text (GTK_ENTRY (pdata->entry_key),gtk_entry_get_text (GTK_ENTRY (entry)));
    gtk_widget_destroy (pdata->netkey);
	gtk_button_clicked (GTK_BUTTON(pdata->save_profil));
    gtk_button_clicked (GTK_BUTTON(pdata->button_connect));
}

