#include <config.h>
#include <glib/gi18n.h>
#include <gtk/gtk.h>
#include <pty.h>
#include <termios.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/time.h>
#include "interface.h"
#include "gwifimeter.h"
#include "but_connect.h"
#include "callback.h"
#include "docklet.h"


void conterm (void *args  )
{
    int pty, enter = 13; // deskryptor pseudoterminala
    char *tab2, *tab3, *net;
    int co, test=0 ,test1,timecon;
    gdouble conprog ;
    GtkTextIter iter, start;
    GtkTextMark *mark;
    gint uid = geteuid();
    pid_t pid;
    GtkTextBuffer *buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (pdata->textview2));
    strcpy(pdata->temppass,"");

    gdk_threads_enter();
    pdata->pass=0;
    gtk_notebook_set_current_page(GTK_NOTEBOOK(pdata->notebook1),2);
    pdata->window_con = okno_postep();
    pdata->window_pas = okno_haslo();

    gdk_threads_leave();

	int cz=0,ca=0;
	struct timeval ti, to;
	long int fa,fb;
	float fc;
void trycon(void)
{
	gettimeofday(&to, NULL);
	fa=to.tv_sec;
	fb=to.tv_usec;
	fc=0.0;
	fc=(float )(to.tv_usec-ti.tv_usec)/1000000;
	fc=fc+(float )(to.tv_sec-ti.tv_sec);
	fc=fc*1000;
	cz=(int )fc;
	//printf(" %d %f\n",cz,fc);
	if(cz>500)
		{
			//printf("time %d\n",cz);
			gettimeofday(&ti, NULL);
		switch (ca)
                {
                case 0:
					gdk_threads_enter();
                    if (pdata->tray_icon)
        gtk_image_set_from_pixbuf (GTK_IMAGE (pdata->icon), pdata->pixcon1);
					gdk_threads_leave();
                    break;
                case 1:
					gdk_threads_enter();
                    if (pdata->tray_icon)
        gtk_image_set_from_pixbuf (GTK_IMAGE (pdata->icon), pdata->pixcon2);
					gdk_threads_leave();
                    break;
                case 2:
					gdk_threads_enter();
                    if (pdata->tray_icon)
        gtk_image_set_from_pixbuf (GTK_IMAGE (pdata->icon), pdata->pixcon3);
					gdk_threads_leave();
                    break;
                case 3:
					gdk_threads_enter();
                    if (pdata->tray_icon)
        gtk_image_set_from_pixbuf (GTK_IMAGE (pdata->icon), pdata->pixcon4);
					gdk_threads_leave();
                    break;
                case 4:
					gdk_threads_enter();
                    if (pdata->tray_icon)
        gtk_image_set_from_pixbuf (GTK_IMAGE (pdata->icon), pdata->pixcon5);
					gdk_threads_leave();
                    break;
                }
			if(++ca>4)ca=0;
		}	
}
int acces(char * interface)
{
   //sleep(1);
   usleep(500000);
	trycon();
	usleep(500000);
   char * dane = readfunc(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),interface,NULL,2);
   char * point = strstr(dane , "Access Point: ");//Access Point: 00:
   char * point1 = strstr(dane , "Cell: ");       // Cell: 00: Cell: Not-Associated
   if (point!=NULL)                               
        {
        if(*(point+16)==':'&& *(point+19)==':'&& *(point+22)==':'&& *(point+25)==':'&& *(point+28)==':'){
                                        g_free(dane);
                                        return (1);
                                        }
        }
        if (point1!=NULL)                               
        {
        if(*(point1+8)==':'&& *(point1+11)==':'&& *(point1+14)==':'&& *(point1+17)==':'&& *(point1+20)==':'){
                                        g_free(dane);
                                        return (1);
                                        }
        }
                g_free(dane);
                return (0);
}
//==========================================================
    void ptysend(gdouble stan ,char *stantext,const char *command,const char *arg1,const char *arg2,const char *arg3,int level)
    {
        stanbar(pdata->progresbar_con, stan,stantext);
        write(pty,command,strlen(command));
        write(pty," ",1);
        write(pty,net,strlen(net));

        if (arg1)
        {
            write(pty," ",1);
            write(pty,arg1,strlen(arg1));
        }

        if (arg2)
        {
            write(pty,arg2,strlen(arg2));
        }

        if (arg3)
        {
            write(pty,arg3,strlen(arg3));
        }

        write(pty,&enter,1);
        test=level;
        //tab3 = g_realloc(tab3,1);
        bzero(tab3,sizeof(tab3));
    }
//==========================================================

//==========================================================
void mesageterminal(gchar * mesage)
            {
                gdk_threads_enter();
                gtk_text_buffer_get_end_iter(buffer, &iter);
                gtk_text_buffer_insert(buffer,&iter,mesage,strlen(mesage));
                gtk_text_buffer_get_end_iter(buffer, &iter);
                mark = gtk_text_buffer_create_mark(buffer,"end",&iter,FALSE);
                gtk_text_view_scroll_to_mark(GTK_TEXT_VIEW(pdata->textview2), mark, 0.0,TRUE, 0.5, 0.5);
                gtk_text_buffer_delete_mark_by_name(buffer,"end");
                gdk_flush ();
                gdk_threads_leave();
            }
//==========================================================
    void openwep(void)
    {
        if (strstr(tab3,"#")!=NULL||(gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton11))==FALSE&&
            gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton4))==FALSE))
        {

            if (test==21)
            {
                stanbar(pdata->progresbar_con, 1.0 ,_("end"));
                write(pty,"exit\n",5);
                //write(pty,&enter,1);
                bzero(tab3,sizeof(tab3));

                if (uid!=0)
                    write(pty,"exit\n",5);
            }

            if (test==20)
            {
                if (gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->combobox_gw))==2&&gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->combobox_ip))!=1)
                {
                    stanbar(pdata->progresbar_con, 0.9 ,_("set gateway"));
                    write(pty,gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_route)),strlen(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_route))));
                    write(pty," add default gw ",16);
                    write(pty,gtk_entry_get_text (GTK_ENTRY (pdata->entry_gw)),strlen(gtk_entry_get_text (GTK_ENTRY (pdata->entry_gw))));
                    write(pty,&enter,1);
                    bzero(tab3,sizeof(tab3));
                    test=21;
                }
                else test=21;
            }

            if ( test == 9)
            {
                switch (gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->combobox_ip)))
                {
                case 0:
                    test=21;
                    break;
                case 1:
                if(acces(net)==1){
                    if(test1 > gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->entry_set_time_to_con1))+1)
                    ptysend(conprog ,_("start DHCP"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_dhcp)),NULL,NULL,NULL,21);
                    else 
                                {
                                ++test1;
                                --timecon;
                                conprog = (conprog+0.005);
                                stanbar(pdata->progresbar_con, conprog ,_("check connect"));
                                //mesageterminal("g_free(profil3) \n");
                                }
                    }
                    else 
                    {
                    --timecon;
                    test1=0;
                    conprog = (conprog+0.005);
                    stanbar(pdata->progresbar_con, conprog ,_("wait to connect"));
                    }
                    break;
                case 2:
                    ptysend(0.8 ,_("set IP"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_ifconfig)),gtk_entry_get_text (GTK_ENTRY (pdata->entry_ip)),NULL,NULL,20);
                    break;
                }
                if ( timecon == 0)test=21;
            }

            if (strstr(tab3,"channel") != NULL && test == 8)
            {
                test1=0;
                conprog=0.7;
                timecon=gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->entry_set_time_to_con));
                switch (gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->comboboxentry_rate)))
                {
                case 0:
                    ptysend(0.7 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate auto",NULL,NULL,9);
                    break;
                case 1:
                    ptysend(0.7 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate 1M",NULL,NULL,9);
                    break;
                case 2:
                    ptysend(0.7 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate 2M",NULL,NULL,9);
                    break;
                case 3:
                    ptysend(0.7 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate 5.5M",NULL,NULL,9);
                    break;
                case 4:
                    ptysend(0.7 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate 11M",NULL,NULL,9);
                    break;
                case 5:
                    ptysend(0.7 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate 9M",NULL,NULL,9);
                    break;
                case 6:
                    ptysend(0.7 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate 18M",NULL,NULL,9);
                    break;
                case 7:
                    ptysend(0.7 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate 24M",NULL,NULL,9);
                    break;
                case 8:
                    ptysend(0.7 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate 36M",NULL,NULL,9);
                    break;
                case 9:
                    ptysend(0.7 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate 54M",NULL,NULL,9);
                    break;
                case 10:
                    ptysend(0.7 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate 108M",NULL,NULL,9);
                    break;
                }
//==========================
            }

            if (strstr(tab3,"mode")!=NULL&&test==7)
            {
                switch (gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->comboboxentry_channel)))
                {
                case 0:
                    ptysend(0.6 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel auto",NULL,NULL,8);
                    break;
                case 1:
                    ptysend(0.6 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 1",NULL,NULL,8);
                    break;
                case 2:
                    ptysend(0.6 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 2",NULL,NULL,8);
                    break;
                case 3:
                    ptysend(0.6 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 3",NULL,NULL,8);
                    break;
                case 4:
                    ptysend(0.6 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 4",NULL,NULL,8);
                    break;
                case 5:
                    ptysend(0.6 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 5",NULL,NULL,8);
                    break;
                case 6:
                    ptysend(0.6 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 6",NULL,NULL,8);
                    break;
                case 7:
                    ptysend(0.6 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 7",NULL,NULL,8);
                    break;
                case 8:
                    ptysend(0.6 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 8",NULL,NULL,8);
                    break;
                case 9:
                    ptysend(0.6 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 9",NULL,NULL,8);
                    break;
                case 10:
                    ptysend(0.6 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 10",NULL,NULL,8);
                    break;
                case 11:
                    ptysend(0.6 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 11",NULL,NULL,8);
                    break;
                case 12:
                    ptysend(0.6 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 12",NULL,NULL,8);
                    break;
                case 13:
                    ptysend(0.6 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 13",NULL,NULL,8);
                    break;
                case 14:
                    ptysend(0.6 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 14",NULL,NULL,8);
                    break;
                }
//===========================
            }

            if (strstr(tab3,"key")!=NULL && test==6)
            {
                switch (gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->comboboxentry_mode)))
                {
                case 0:
                    ptysend(0.5 ,_("set mode"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"mode managed",NULL,NULL,7);
                    break;
                case 1:
                    ptysend(0.5 ,_("set mode"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"mode ad-hoc",NULL,NULL,7);
                    break;
                case 2:
                    ptysend(0.5 ,_("set mode"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"mode master",NULL,NULL,7);
                    break;
                case 3:
                    ptysend(0.5 ,_("set mode"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"mode monitor",NULL,NULL,7);
                    break;
                }
//===============================
            }

            if (strstr(tab3,"essid")!=NULL && test==5)
            {
                switch (gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->combobox_keymode)))
                {
                case 0:
                    ptysend(0.4 ,_("set key"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"key off",NULL,NULL,6);
                    break;
                case 1:
                    ptysend(0.4 ,_("set key"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"key ","open ",gtk_entry_get_text (GTK_ENTRY (pdata->entry_key)),6);
                    break;
                case 2:
                    ptysend(0.4 ,_("set key"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"key ","restricted ",gtk_entry_get_text (GTK_ENTRY (pdata->entry_key)),6);
                    break;
                case 3:
                    break;
                }
            }

            if (test==4)
            {
                usleep(200000);
                ptysend(0.35 ,_("set essid"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig))," essid \"",
                        gtk_entry_get_text (GTK_ENTRY (pdata->entry_nazwa)),"\"",5);
            }

//=================================================================================================================
//wpa_cli -p /var/run/wpa_supplicant terminate quit
            if (strstr(tab3,"up")!=NULL&&test==3)
            {
                if (findfile(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_ctrl)))>0)
                {
                    usleep(200000);
                    stanbar(pdata->progresbar_con, 0.3 ,_("supplicant terminate"));
                    write(pty,gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_cli)),strlen(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_cli))));
                    write(pty," -p ",4);
                    write(pty,gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_ctrl)),strlen(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_ctrl))));
                    write(pty," terminate quit\n",strlen(" terminate quit\n"));
//write(pty,"wpa_cli -p /var/run/wpa_supplicant terminate quit\n",strlen("wpa_cli -p /var/run/wpa_supplicant terminate quit\n"));
                    bzero(tab3,sizeof(tab3));
                }
                test=4;
            }
//=================================================================================================================
            if (test==2)
                ptysend(0.2 ,_("interface up"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_ifconfig)),"up",NULL,NULL,3);

            if (strstr(gtk_combo_box_get_active_text (GTK_COMBO_BOX (pdata->combobox_mac)),"Ustaw")!=NULL && test==1)
                ptysend(0.1 ,_("set MAC address"),"ifconfig","hw ether ",gtk_entry_get_text (GTK_ENTRY (pdata->entry_mac)),NULL,2);
            else if (test==1)
                test=2;

            if (test==0)
            {
                if (!GTK_WIDGET_VISIBLE (pdata->window_con)&&GTK_WIDGET_VISIBLE (pdata->window))
                {
                    gdk_threads_enter();
                    gtk_widget_show (pdata->window_con);
                    gdk_threads_leave();
                }
                ptysend(0.0 ,_("interface down"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_ifconfig)),"down",NULL,NULL,1);
            }

        }
    }
//==========================================================
    void ralink(void)
    {
        if (strstr(tab3,"#")!=NULL||(gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton11))==FALSE&&
            gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton4))==FALSE))
        {
        

            if (test==23)
            {
                stanbar(pdata->progresbar_con, 1.0 ,_("end"));
                write(pty,"exit\n",5);
                //write(pty,&enter,1);
                bzero(tab3,sizeof(tab3));

                if (uid!=0)
                    write(pty,"exit\n",5);
            }
//==================================
             if (test==22)
            {
                if (gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->combobox_gw))==2&&gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->combobox_ip)) != 1)
                {
                    stanbar(pdata->progresbar_con, 0.9 ,_("set gateway"));
                    write(pty,gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_route)),strlen(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_route))));
                    write(pty," add default gw ",16);
                    write(pty,gtk_entry_get_text (GTK_ENTRY (pdata->entry_gw)),strlen(gtk_entry_get_text (GTK_ENTRY (pdata->entry_gw))));
                    write(pty,&enter,1);
                    bzero(tab3,sizeof(tab3));
                    test=23;
                }
                else test=23;
            }
//=============================
            if ( test == 11)
            {
                switch (gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->combobox_ip)))
                {
                case 0:
                    test=23;
                    break;
                case 1:
                if(acces(net)==1){
                    if(test1 > gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->entry_set_time_to_con1))+1)
                    {
                    ptysend(conprog ,_("start DHCP"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_dhcp)),NULL,NULL,NULL,23);
                    }
                    else 
                                {
                                ++test1;
                                --timecon;
                                conprog = (conprog+0.005);
                                stanbar(pdata->progresbar_con, conprog ,_("check connect"));
                                }
                    }
                    else 
                    {
                    --timecon;
                    test1=0;
                    conprog = (conprog+0.005);
                    stanbar(pdata->progresbar_con, conprog ,_("wait to connect"));
                    }
                    break;
                case 2:
                    ptysend(0.8 ,_("set IP"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_ifconfig)),gtk_entry_get_text (GTK_ENTRY (pdata->entry_ip)),NULL,NULL,22);
                    break;
                }
                if ( timecon == 0)test=23;
            }
//============================

            if (strstr(tab3,"TxRate")!=NULL && test==10)
            {
                test1=0;
                conprog=0.7;
                timecon=gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->entry_set_time_to_con));
                switch (gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->combobox_keymode)))
                {
                case 0:
                 //ptysend(0.7 ,_("set key"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"key off",NULL,NULL,11);
                 ptysend(0.7 ,_("set key"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","EncrypType=NONE",NULL,11);
                    break;
                case 1:
              //ptysend(0.7 ,_("set key"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"key ","open ",gtk_entry_get_text (GTK_ENTRY (pdata->entry_key)),11);
              ptysend(0.7 ,_("set key"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","AuthMode=SHARED ",NULL,11);
              ptysend(0.7 ,_("set key"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","EncrypType=WEP",NULL,11);
              ptysend(0.7 ,_("set key"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","DefaultKeyID=1",NULL,11);
              ptysend(0.7 ,_("set key"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","Key1=",gtk_entry_get_text (GTK_ENTRY (pdata->entry_key)),11);
                    break;
                case 2:
                    ptysend(0.7 ,_("set key"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"key ","restricted ",gtk_entry_get_text (GTK_ENTRY (pdata->entry_key)),11);
                    break;
               case 3:
                //iwpriv ra0 set AuthMode=WPAPSK
                ptysend(0.7 ,_("set key"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","AuthMode=WPAPSK ",NULL,11);
                ptysend(0.7 ,_("set key"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","EncrypType=TKIP",NULL,11);
                ptysend(0.7 ,_("set key"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","WPAPSK=",gtk_entry_get_text (GTK_ENTRY (pdata->entry_key)),11);
                    break;
                case 4:
                //iwpriv ra0 set AuthMode=WPAPSK
                ptysend(0.7 ,_("set key"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","AuthMode=WPAPSK ",NULL,11);
                ptysend(0.7 ,_("set key"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","EncrypType=AES",NULL,11);
                ptysend(0.7 ,_("set key"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","WPAPSK=",gtk_entry_get_text (GTK_ENTRY (pdata->entry_key)),11);
                    break;
                }
            }

            if (strstr(tab3,"Channel") != NULL && test == 9)
            {
                switch (gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->comboboxentry_rate)))
                {
                case 0:
                    ptysend(0.6 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set TxRate 0",NULL,NULL,10);
                    break;
                case 1:
                    ptysend(0.6 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set TxRate 1",NULL,NULL,10);
                    break;
                case 2:
                    ptysend(0.6 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set TxRate 2",NULL,NULL,10);
                    break;
                case 3:
                    ptysend(0.6 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set TxRate 3",NULL,NULL,10);
                    break;
                case 4:
                    ptysend(0.6 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set TxRate 4",NULL,NULL,10);
                    break;
                case 5:
                    ptysend(0.6 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set TxRate 6",NULL,NULL,10);
                    break;
                case 6:
                    ptysend(0.6 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set TxRate 8",NULL,NULL,10);
                    break;
                case 7:
                    ptysend(0.6 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set TxRate 9",NULL,NULL,10);
                    break;
                case 8:
                    ptysend(0.6 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set TxRate 10",NULL,NULL,10);
                    break;
                case 9:
                    ptysend(0.6 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set TxRate 12",NULL,NULL,10);
                    break;
                case 10:
                    ptysend(0.6 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set TxRate 0",NULL,NULL,10);
                    break;
                default:
                    ptysend(0.6 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set TxRate 0",NULL,NULL,10);
                }
            }

            if (strstr(tab3,"SSID")!=NULL&&test==8)
            {
                switch (gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->comboboxentry_channel)))
                {
                case 0:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","Channel 0",NULL,9);
                    break;
                case 1:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","Channel 1",NULL,9);
                    break;
                case 2:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","Channel 2",NULL,9);
                    break;
                case 3:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","Channel 3",NULL,9);
                    break;
                case 4:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","Channel 4",NULL,9);
                    break;
                case 5:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","Channel 5",NULL,9);
                    break;
                case 6:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","Channel 6",NULL,9);
                    break;
                case 7:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","Channel 7",NULL,9);
                    break;
                case 8:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","Channel 8",NULL,9);
                    break;
                case 9:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","Channel 9",NULL,9);
                    break;
                case 10:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","Channel 10",NULL,9);
                    break;
                case 11:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","Channel 11",NULL,9);
                    break;
                case 12:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","Channel 12",NULL,9);
                    break;
                case 13:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","Channel 13",NULL,9);
                    break;
                case 14:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","Channel 14",NULL,9);
                    break;
                default:
                ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","Channel 0",NULL,9);
                }
            }

            if (strstr(tab3,"SSID")!=NULL && test==7)
            {
                switch (gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->comboboxentry_mode)))
                {
                case 0:
               ptysend(0.4 ,_("set mode"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set NetworkType=Infra",NULL,NULL,8);
                    break;
                case 1:
               ptysend(0.4 ,_("set mode"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set NetworkType=Adhoc",NULL,NULL,8);
                    break;
                case 2:
               ptysend(0.4 ,_("set mode"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set NetworkType=Infra",NULL,NULL,8);
                    break;
                case 3:
               ptysend(0.4 ,_("set mode"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set NetworkType=Infra",NULL,NULL,8);
                    break;
               default:
               ptysend(0.4 ,_("set mode"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set NetworkType=Infra",NULL,NULL,8);
                }
            }
            if (test==6)
            {
                usleep(200000);
                //ptysend(0.35 ,_("set essid"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig))," essid \"",
                //        gtk_entry_get_text (GTK_ENTRY (pdata->entry_nazwa)),"\"",7);
ptysend(0.35 ,_("set essid"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwpriv)),"set ","SSID=",gtk_entry_get_text (GTK_ENTRY (pdata->entry_nazwa)),8);
            }
//=======================================================
            if (test==5)
            {
                if (findfile(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_ctrl)))>0)
                {
                    usleep(200000);
                    stanbar(pdata->progresbar_con, 0.3 ,_("supplicant terminate"));
                    write(pty,gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_cli)),strlen(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_cli))));
                    write(pty," -p ",4);
                    write(pty,gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_ctrl)),strlen(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_ctrl))));
                    write(pty," terminate quit\n",strlen(" terminate quit\n"));
//write(pty,"wpa_cli -p /var/run/wpa_supplicant terminate quit\n",strlen("wpa_cli -p /var/run/wpa_supplicant terminate quit\n"));
                    bzero(tab3,sizeof(tab3));
                }
                test=6;
            }

            if (test==2)
            {
                ptysend(0.0 ,_("interface up"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_ifconfig)),"up",NULL,NULL,5);
                usleep(200000);
            }       
//========================================================
            if (strstr(gtk_combo_box_get_active_text (GTK_COMBO_BOX (pdata->combobox_mac)),"Ustaw")!=NULL && test==1)
                ptysend(0.1 ,_("set MAC address"),"ifconfig","hw ether ",gtk_entry_get_text (GTK_ENTRY (pdata->entry_mac)),NULL,2);
            else if (test==1)test=2;

            if (test==0)
            {
                if (!GTK_WIDGET_VISIBLE (pdata->window_con)&&GTK_WIDGET_VISIBLE (pdata->window))
                {
                    gdk_threads_enter();
                    gtk_widget_show (pdata->window_con);
                    gdk_threads_leave();
                }
                ptysend(0.0 ,_("interface down"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_ifconfig)),"down",NULL,NULL,1);
            }

        }
    }
//=====================================================================================================
    void wpa(void)
    {
        if (strstr(tab3,"#")!=NULL||(gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton11))==FALSE&&
            gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton4))==FALSE))
        //printf("test\n");
        {

            if (test==21)
            {
                stanbar(pdata->progresbar_con, 1.0 ,_("end"));
                write(pty,"exit\n",5);
                //write(pty,&enter,1);
                bzero(tab3,sizeof(tab3));
                test=22;
                if (uid!=0)
                    write(pty,"exit\nexit\n",5);
            }

            if (test==20)
            {
                if (gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->combobox_gw))==2)
                {
                    stanbar(pdata->progresbar_con, 0.9 ,_("set gateway"));
                    write(pty,gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_route)),strlen(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_route))));
                    write(pty," add default gw ",16);
                    write(pty,gtk_entry_get_text (GTK_ENTRY (pdata->entry_gw)),strlen(gtk_entry_get_text (GTK_ENTRY (pdata->entry_gw))));
                    write(pty,&enter,1);
                    bzero(tab3,sizeof(tab3));
                    test=21;
                }
                else test=21;
            }

            if ( test == 10)
            {
                switch (gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->combobox_ip)))
                {
                case 0:
                    test=21;
                    break;
                case 1:
                if(acces(net)==1){
                    if(test1 > gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->entry_set_time_to_con1))+1)
                    {
                    ptysend(conprog ,_("start DHCP"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_dhcp)),NULL,NULL,NULL,21);
                    }
                    else 
                                {
                                ++test1;
                                --timecon;
                                conprog = (conprog+0.005);
                                stanbar(pdata->progresbar_con, conprog ,_("check connect"));
                                }
                    }
                    else 
                    {
                    --timecon;
                    test1=0;
                    conprog = (conprog+0.005);
                    stanbar(pdata->progresbar_con, conprog ,_("wait to connect"));
                    }
                    break;
                case 2:
                    ptysend(0.8 ,_("set IP"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_ifconfig)),gtk_entry_get_text (GTK_ENTRY (pdata->entry_ip)),NULL,NULL,20);
                    break;
                }
                if ( timecon == 0)test=21;
            }
//=============================================================================================================
            if (test==9){
            //mesageterminal("test9\n");
                test1=0;
                conprog=0.7;
                timecon=gtk_spin_button_get_value(GTK_SPIN_BUTTON( pdata->entry_set_time_to_con));
                stanbar(pdata->progresbar_con, 0.7 ,_("set wpa_supplicant"));
// wpa_supplicant -c wifi_config.cfg -i eth2 -D wext -B
                write(pty,gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_supp)),strlen(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_supp))));
                write(pty," -c ",4);
                write(pty,gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_cfg)),strlen(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_cfg))));
                write(pty," -i ",4);
                write(pty,net,strlen(net));
                write(pty," -D ",4);
                write(pty,gtk_combo_box_get_active_text (GTK_COMBO_BOX (pdata->comboboxentry_wpa_ctrl)),strlen(gtk_combo_box_get_active_text (GTK_COMBO_BOX (pdata->comboboxentry_wpa_ctrl))));
                write(pty," -B\n",4);
                bzero(tab3,sizeof(tab3));
                test=10;
            }
//================================================================================================================
//wpa_passphrase test tajnehaslo > wifi_config.cfg
            if (test==8)
            {
                char * passphrase = readfunc(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_pas)),gtk_entry_get_text (GTK_ENTRY (pdata->entry_nazwa)),gtk_entry_get_text (GTK_ENTRY (pdata->entry_key)),0);
                stanbar(pdata->progresbar_con, 0.6 ,_("create wpa_config"));
                char *profil3 = (char*)g_malloc(500);//profil3 = realloc(profil3, 7*sizeof(char));
                strcpy(profil3,"ctrl_interface=");
                strcat(profil3,gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_ctrl)));
                strcat(profil3,"\nctrl_interface_group=0\neapol_version=1\nfast_reauth=1\n");
                if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton6)))strcat(profil3,"ap_scan=1\n");
                strcat(profil3,passphrase);
                if(strstr(profil3,"}")!=0)
                {
                *(strstr(profil3,"}"))='\0';
                if(gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->combobox_keymode))==3)
                        {
                        if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton6)))strcat(profil3,"	scan_ssid=1\n");
                        strcat(profil3,"	priority=2\n	key_mgmt=WPA-PSK\n	pairwise=TKIP\n}\n");
                        }
                else {
                        if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton6)))strcat(profil3,"	scan_ssid=1\n");
                        strcat(profil3,"	priority=2\n	key_mgmt=WPA-PSK\n	pairwise=CCMP\n}\n");
                        }
                }
                int file;
                file = open(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_cfg)),O_WRONLY|O_CREAT|O_TRUNC,S_IRUSR|S_IWUSR);

                if (file > 0 )
                {
                    write(file,profil3,strlen(profil3));
                    close(file);
                    //mesageterminal("save wpa_cfg \n");
                }
                g_free(passphrase);
                //mesageterminal("g_free(passphrase) \n");
                //printf("- %d\n",strlen(profil3));
                g_free(profil3);
                //mesageterminal("g_free(profil3) \n");
                test=9;
            }
            //mesageterminal("*");
//======================================================================================================
            if (strstr(tab3,"channel") != NULL && test == 7)
            {
                switch (gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->comboboxentry_rate)))
                {
                case 0:
                    ptysend(0.55 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate auto",NULL,NULL,8);
                    break;
                case 1:
                    ptysend(0.55 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate 1M",NULL,NULL,8);
                    break;
                case 2:
                    ptysend(0.55 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate 2M",NULL,NULL,8);
                    break;
                case 3:
                    ptysend(0.55 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate 5.5M",NULL,NULL,8);
                    break;
                case 4:
                    ptysend(0.55 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate 11M",NULL,NULL,8);
                    break;
                case 5:
                    ptysend(0.55 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate 9M",NULL,NULL,8);
                    break;
                case 6:
                    ptysend(0.55 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate 18M",NULL,NULL,8);
                    break;
                case 7:
                    ptysend(0.55 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate 24M",NULL,NULL,8);
                    break;
                case 8:
                    ptysend(0.55 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate 36M",NULL,NULL,8);
                    break;
                case 9:
                    ptysend(0.55 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate 54M",NULL,NULL,8);
                    break;
                case 10:
                    ptysend(0.55 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate 108M",NULL,NULL,8);
                    break;
                default: 
                    ptysend(0.55 ,_("set rate"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"rate auto",NULL,NULL,8);
                }
            }
            if (strstr(tab3,"mode")!=NULL&&test==6)
            {
                switch (gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->comboboxentry_channel)))
                {
                case 0:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel auto",NULL,NULL,7);
                    break;
                case 1:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 1",NULL,NULL,7);
                    break;
                case 2:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 2",NULL,NULL,7);
                    break;
                case 3:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 3",NULL,NULL,7);
                    break;
                case 4:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 4",NULL,NULL,7);
                    break;
                case 5:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 5",NULL,NULL,7);
                    break;
                case 6:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 6",NULL,NULL,7);
                    break;
                case 7:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 7",NULL,NULL,7);
                    break;
                case 8:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 8",NULL,NULL,7);
                    break;
                case 9:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 9",NULL,NULL,7);
                    break;
                case 10:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 10",NULL,NULL,7);
                    break;
                case 11:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 11",NULL,NULL,7);
                    break;
                case 12:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 12",NULL,NULL,7);
                    break;
                case 13:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 13",NULL,NULL,7);
                    break;
                case 14:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel 14",NULL,NULL,7);
                    break;
                default:
                    ptysend(0.5 ,_("set channel"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"channel auto",NULL,NULL,7);
                }
            }
            if (strstr(tab3,"essid")!=NULL && test==5)
            {
                switch (gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->comboboxentry_mode)))
                {
                case 0:
                    ptysend(0.4 ,_("set mode"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"mode managed",NULL,NULL,6);
                    break;
                case 1:
                    ptysend(0.4 ,_("set mode"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"mode ad-hoc",NULL,NULL,6);
                    break;
                case 2:
                    ptysend(0.4 ,_("set mode"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"mode master",NULL,NULL,6);
                    break;
                case 3:
                    ptysend(0.4 ,_("set mode"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"mode monitor",NULL,NULL,6);
                    break;
                default:
                    ptysend(0.4 ,_("set mode"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),"mode managed",NULL,NULL,6);
                }
            }
            if (test==4)
            {
                usleep(200000);
                ptysend(0.35 ,_("set essid"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig))," essid \"",
                        gtk_entry_get_text (GTK_ENTRY (pdata->entry_nazwa)),"\"",5);
            }       
//=================================================================================================================
//wpa_cli -p /var/run/wpa_supplicant terminate quit
            if (strstr(tab3,"up")!=NULL && test==3){
                if (findfile(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_ctrl)))>0)
                {
                    usleep(200000);
                    stanbar(pdata->progresbar_con, 0.3 ,_("supplicant terminate"));
                    write(pty,gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_cli)),strlen(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_cli))));
                    write(pty," -p ",4);
                    write(pty,gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_ctrl)),strlen(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_wpa_ctrl))));
                    write(pty," terminate quit\n",strlen(" terminate quit\n"));
//write(pty,"wpa_cli -p /var/run/wpa_supplicant terminate quit\n",strlen("wpa_cli -p /var/run/wpa_supplicant terminate quit\n"));
                    bzero(tab3,sizeof(tab3));
                }
                test=4;
            }
//===================================================================================================================
            if (test==2)
                ptysend(0.2 ,_("interface up"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_ifconfig)),"up",NULL,NULL,3);

            if (gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->combobox_mac))==1 && test==1)
                ptysend(0.1 ,_("set MAC address"),"ifconfig","hw ether ",gtk_entry_get_text (GTK_ENTRY (pdata->entry_mac)),NULL,2);
            else if (test==1)
                test=2;

            if (test==0){
                if (!GTK_WIDGET_VISIBLE (pdata->window_con)&&GTK_WIDGET_VISIBLE (pdata->window))
                {
                    gdk_threads_enter();
                    gtk_widget_show (pdata->window_con);
                    gdk_threads_leave();
                }
                ptysend(0.0 ,_("interface down"),gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_ifconfig)),"down",NULL,NULL,1);
            }

        }
    }
//=========================================================
    int tmelaps1(int socket , int czass,int uczas)
    {
        fd_set rfds;
        struct timeval tv;
        int retval;
        FD_ZERO(&rfds);
        FD_SET(socket, &rfds);
        tv.tv_sec = czass;
        tv.tv_usec = uczas;
        retval = select(socket+1, &rfds, NULL, NULL, &tv);

        if (retval){
            return 1;
        }
        else{
            return 0;
        }
    }
//=========================================================

    int tty_raw(int fd)
    {
        struct termios termios_p[1];

        //if (tcgetattr(fd, attr) == -1) return -1;
        bzero(termios_p,sizeof(termios_p));

        termios_p->c_iflag &= ~(IGNBRK | BRKINT | PARMRK | ISTRIP | INLCR | IGNCR | ICRNL | IXON);
        termios_p->c_oflag &= ~OPOST;
        termios_p->c_lflag &= ~(ECHO | ECHONL | ICANON | ISIG | IEXTEN);
        termios_p->c_cflag &= ~(CSIZE | PARENB);
        termios_p->c_cflag |= CS8;


        return tcsetattr(fd, TCSANOW, termios_p);
    }


//=========================================================
    pdata->prostan=0;


    pid = forkpty(&pty, NULL, NULL, NULL);
    if (pid == -1)
    {
        printf("Forking error\n");
        perror("forkpty");
        exit(-1);
    }
    else if (pid == 0)
    {
        if (uid==0||(gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton11))==FALSE&&
        gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton4))==FALSE))execl("/bin/sh","sh", NULL);
        else {
                    if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton4)))
                    execl(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_sudo)),"sudo","/bin/sh",NULL);
                    if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton11)))
                    execl(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_su)),"su", "--shell","/bin/sh",NULL);
              }
    }
    sleep(1);
    //tab4 = (char *) g_malloc(100);
    tab3 = (char *) g_malloc(1);
    tab2 = (char *) g_malloc(100);
    net = (char *) g_malloc(strlen(pdata->interface)+1);
    strcpy(net,pdata->interface);
    gdk_threads_enter();
//gtk_text_buffer_get_iter_at_offset(buffer,&iter, -1);
    gtk_text_buffer_get_end_iter(buffer, &iter);
    gtk_text_buffer_get_start_iter (buffer, &start);
    gtk_text_buffer_delete(buffer,&start,&iter);
    gdk_flush ();
    gdk_threads_leave();
    //bzero(tab4,sizeof(tab4));
    bzero(tab3,sizeof(tab3));
    bzero(tab2,sizeof(tab2));
    //if(uid!=0)write(pty,"su --shell /bin/sh\n",19);
    pdata->connect=1;

	gettimeofday(&ti, NULL);
    while (1)
    {
	trycon();
        if (pdata->prostan)
        {
            break;
        }
        usleep(1000);
        if (tmelaps1(pty , 0,1000))
        {
            co=read(pty,tab2,99);
//    write(1,tab2,co);
            if (co<0)
            {
                break;
            }
            strncat(tab3 = g_realloc(tab3,strlen(tab3)+co+1) ,tab2,co);
//   if(test>0)
            {
                gdk_threads_enter();
                gtk_text_buffer_get_end_iter(buffer, &iter);
                gtk_text_buffer_insert(buffer,&iter,tab2,co);
                gtk_text_buffer_get_end_iter(buffer, &iter);
                mark = gtk_text_buffer_create_mark(buffer,"end",&iter,FALSE);
                gtk_text_view_scroll_to_mark(GTK_TEXT_VIEW(pdata->textview2), mark, 0.0,TRUE, 0.5, 0.5);
                gtk_text_buffer_delete_mark_by_name(buffer,"end");
                gdk_flush ();
                gdk_threads_leave();
            }
        }
        else {
            if (uid!=0&&test==0&&strstr(tab3,"#")==NULL
            &&(gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton11))==TRUE||
            gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton4))==TRUE))
                 {
                  if (pdata->pass==2)//--------------pass2
                    {
                    write(pty,pdata->temppass,strlen(pdata->temppass));
                    write(pty,&enter,1);
                    bzero(tab3,sizeof(tab3));
                    pdata->pass=3;
                    bzero(pdata->temppass,sizeof(pdata->temppass));
                    }
                  if (pdata->pass==0)//---------------pass0
                     {
                       if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton9)))
	               {
	        gchar *pass2 = paread (pdata->cryptpas);
			strcpy(pdata->temppass,pass2);
			g_free (pass2);
			gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(pdata->progresbar_con),0);
			pdata->pass=2;
			sleep(1);
	                }
			else
			{
                         pdata->pass=1;
                         gdk_threads_enter();
                         gtk_widget_show (pdata->window_pas);
                         gdk_threads_leave();
			}
                     }
                 }
                 else if(test==0)pdata->pass=3;
            if (uid==0||pdata->pass==3)//------------------pass3
            {
            switch (gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->comboboxentry_wpa_mode)))
            {
            case 0:
            if(strstr(net,"ra")!=NULL)ralink();
            else{
            switch (gtk_combo_box_get_active(GTK_COMBO_BOX (pdata->combobox_keymode)))
                {
                case 0:
                    openwep();
                    break;
                case 1:
                    openwep();
                    break;
                case 2:
                    openwep();
                    break;
                case 3:
                    wpa();
                    break;
                case 4:
                    wpa();
                    break;
                case 5:
                    wpa();
                    break;
                }
                break;
            case 1:
                wpa();
                break;
            case 2:
                ralink();
                break;
            }

                }
           }
        }
    }
    g_free(tab3);
    g_free(tab2);
    g_free(net);
    gdk_threads_enter();
    if (pdata->window_con)
{
    gtk_widget_destroy(pdata->window_con);
	pdata->window_con=NULL;
}
    gtk_notebook_set_current_page   (GTK_NOTEBOOK(pdata->notebook1),1);
    pdata->connect=0;
    if (pdata->window_pas)
{
    gtk_widget_destroy(pdata->window_pas);
	pdata->window_pas=NULL;
	}
    gdk_threads_leave();
}

void passcancel (GtkWidget *entry)
{
    gtk_widget_hide (pdata->window_pas);
    pdata->pass=2;
    pdata->prostan=1;
}
void window_pas_del(void)
{
    gtk_widget_hide (pdata->window_pas);
}
void passcheck (GtkWidget *entry)
{
    strcpy(pdata->temppass,gtk_entry_get_text (GTK_ENTRY (entry)));
    gtk_widget_hide (pdata->window_pas);
    gtk_notebook_set_current_page   (GTK_NOTEBOOK(pdata->notebook1),2);
    gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(pdata->progresbar_con),0);
    pdata->pass=2;
}
void but_connect (void )
{
    GError    *err1 = NULL ;
    g_thread_pool_push(con_but,GUINT_TO_POINTER (1),&err1);
}
void realize_window(void)
{
//printf("start realize\n");

}

