#ifndef _OSCONFIG_DEFINED
#define _OSCONFIG_DEFINED

/* OpenSSL-specific defines */

#define OPENSSL_EXTERN	extern
#define OPENSSL_GLOBAL

#include <stdlib.h>			/* For malloc() */
#include <string.h>			/* For memset() */


/* General defines */

#include <limits.h>
#if ULONG_MAX > 0xFFFFFFFFUL
  #define SIXTY_FOUR_BIT
#else
  #define THIRTY_TWO_BIT
#endif /* Machine word size */

	#define B_ENDIAN
	#define BN_LLONG
	#define BF_PTR
	#define DES_UNROLL
	#define RC4_CHAR
	#define RC4_CHUNK	


/* Make sure we weren't missed out.  See the comment in the Cray section
   for the exception for Crays */
//linux-mipsel",   "gcc:-DL_ENDIAN -DTERMIO -O3 -fomit-frame-pointer -Wall::-D_REENTRANT::-ldl:BN_LLONG::::::::::dlfcn:linux-shared:-fPIC::.so.\$(SHLIB_MAJOR).\$(SHLIB_MINOR)",

#endif /* _OSCONFIG_DEFINED */
